unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls,
  Vcl.Buttons, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TLineSeries;
    GroupBox1: TGroupBox;
    etaEdit: TLabeledEdit;
    RadiusEdit: TLabeledEdit;
    gammaEdit: TLabeledEdit;
    GammaBtn: TBitBtn;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    mEdit: TLabeledEdit;
    VEdit: TLabeledEdit;
    angleEdit: TLabeledEdit;
    CalcBtn: TBitBtn;
    gEdit: TLabeledEdit;
    tEdit: TLabeledEdit;
    Series2: TLineSeries;
    RadioGroup1: TRadioGroup;
    GroupBox3: TGroupBox;
    RelativeEdit: TLabeledEdit;
    mBtn: TBitBtn;
    CheckBox1: TCheckBox;
    Series3: TLineSeries;
    Series4: TLineSeries;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure GammaBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CalcBtnClick(Sender: TObject);
    procedure mBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math;

// :CRWvZ (gamma)
// CRxɔႷ郌CmYP̑x̌vZ
procedure TForm1.GammaBtnClick(Sender: TObject);
var
  a     : double;   // a
  eta   : double;   // CSW
  gamma : double;   // CRW
  ch    : integer;
  rv    : double;     // CmY1̑x
begin
  memo1.Clear;
  val(etaEdit.Text, eta, ch);
  if ch <> 0 then begin
    memo1.Text := ':CSWɊԈႢ܂B';
    exit;
  end;
  val(RadiusEdit.Text, a, ch);
  if ch <> 0 then begin
    memo1.Text := 'a:̔aɊԈႢ܂B';
    exit;
  end;
  gamma := 6 * pi * a * eta;
  gammaedit.Text := floatTostr(gamma);   // CRW
  rv := eta / a;
  memo1.Lines.Append('CmY Re <= 1 ̑x' + floatTostr(rv) + ' m');
end;

// ̎ʌvZ
// vZ͊ȒPԂȂ
procedure TForm1.mBtnClick(Sender: TObject);
var
  a     : double;   // a
  r     : double;   // x
  m     : double;   // 
  ch    : integer;
begin
  val(RadiusEdit.Text, a, ch);
  if ch <> 0 then begin
    memo1.Text := 'a:̔aɊԈႢ܂B';
    exit;
  end;
  val(RelativeEdit.Text, r, ch);
  if ch <> 0 then begin
    memo1.Text := 'dɊԈႢ܂B';
    exit;
  end;
  m := a * a * a * pi * 4 / 3 * r;    // ̎ʌvZ
  medit.Text := floatTostrF(m * 1000, ffGeneral, 10,5);
end;

// ΕˌvZ ւ̓˂͖
// (vZ)
procedure TForm1.CalcBtnClick(Sender: TObject);
var
  gamma : double;     //  CRW
  m     : double;     // m  
  v0    : double;     // x
  deg   : double;     // px deg
  rad   : double;     // px rad
  g     : double;     // d͉x
  Lg    : double;     // Lg = /m
  v0x   : double;     // xx
  v0y   : double;     // yx
  vxt   : double;     // tbxx
  vyt   : double;     // tbyx
  xt    : double;     // tbxʒu
  yt    : double;     // tbyʒu
  vxtn   : double;    // CRȂtbxx
  vytn   : double;    // CRȂtbyx
  xtn    : double;    // CRȂtbxʒu
  ytn    : double;    // CRȂtbyʒu
  th    : double;     // ō_B
  h     : double;     // ō_
  hx    : double;     // ō_x
  h0x   : double;     // ōB_
  vyf   : double;     // ԁx
  ch    : integer;
  dt    : double;     // t
  j     : integer;    // 
  t     : double;     // 
  tm    : double;     // Otő厞
  y     : double;     // yʒu
  sc    : double;     // XP[
  i: Integer;         //


  function calc_vxt(t: double): double;     // tbxx
  begin
    result := v0x * exp(-Lg * t);
  end;

  function calc_vyt(t: double): double;     // tbyx
  begin
    result := -g / Lg + 1 / Lg * (g + Lg * v0y) * exp(-Lg * t);
  end;

  function calc_xt(t: double): double;      // tbxʒu
  begin
    result := v0x / Lg * (1 - exp(-Lg * t));
  end;

  function calc_yt(t: double): double;      // tbyʒu
  begin
    result := -g * t / Lg + 1 / Lg / Lg * (g + Lg * v0y) * (1 - exp(-Lg * t));
  end;

  function calc_th: double;                 // ō_B
  begin
    result := 1 / Lg * ln((g + Lg * v0y) / g);
  end;

  function calc_h: double;                  // ō_
  begin
    result := -g / Lg / Lg * ln((g + Lg * v0y) / g) + (v0y / Lg);
  end;

  function calc_hx: double;                 // ō_x
  begin
    result := v0x * v0y / (g + Lg * v0y);
  end;

  function calc_h0x: double;                // ԁB_
  begin
    result := v0x / Lg;
  end;

  function calc_vyf: double;                // ԁx
  begin
    result := m * g / gamma;
  end;

  function xtoy(x: double): double;         // X->y ϊ
  begin
    if x = 0 then begin
      result := 0;
      exit;
    end;
    if 1 - x * Lg / v0x < 0 then begin      // lnZG[
      result := x / v0x * (v0y + 1 / Lg * g) + 1 / (Lg * Lg) * g;
      exit;
    end;
    result := x / v0x * (v0y + 1 / Lg * g) + 1 / (Lg * Lg) * g * ln(1 - x * Lg / v0x);
  end;

  function no_drag_x(t: double): double;    // CRx
  begin
    result := v0x * t;
  end;

  function no_drag_y(t: double): double;    // CRy
  begin
    result := -1 / 2 * g * t * t + v0y * t;
  end;

  function no_drag_vy(t: double): double;   // CRyx
  begin
    result := -g * t + v0y;
  end;

begin
  memo1.Clear;
  val(gammaedit.Text, gamma, ch);
  if ch <> 0 then begin
    memo1.Text := ':CRWɊԈႢ܂B';
    exit;
  end;
  val(medit.Text, m, ch);
  if ch <> 0 then begin
    memo1.Text := 'm:ʂɊԈႢ܂B';
    exit;
  end;
  val(VEdit.Text, v0, ch);
  if ch <> 0 then begin
    memo1.Text := 'v:xɊԈႢ܂B';
    exit;
  end;
  val(angleedit.Text, deg, ch);
  if ch <> 0 then begin
    memo1.Text := ':ˊpxɊԈႢ܂B';
    exit;
  end;
  if deg > 90 then begin
    memo1.Text := ':ˊpx90ȓɂĉB';
    exit;
  end;
  if deg < 0 then begin
    memo1.Text := ':ˊpx0([)ȏɂĂB';
    exit;
  end;
  val(gEdit.Text, g, ch);
  if ch <> 0 then begin
    memo1.Text := 'g:d͉xɊԈႢ܂B';
    exit;
  end;
  val(tEdit.Text, tm, ch);
  if ch <> 0 then begin
    memo1.Text := 't:OtԂɊԈႢ܂B';
    exit;
  end;
  rad := deg / 180 * pi;        // ˊpx radP
  Lg := gamma / m;              // CRW
  v0x := cos(rad) * v0;         // xx
  v0y := sin(rad) * v0;         // yx
  h := calc_h;
  memo1.Lines.Append('ɑxxꍇ̂ݑxɒRႵ܂B');
  memo1.Lines.Append('vZʂ́A_lłB');
  memo1.Lines.Append('@ō_              ' + floatTostr(h) + ' m');
  hx := calc_hx;
  memo1.Lines.Append('@ō_x            ' + floatTostr(hx) + ' m');
  th := calc_th;
  memo1.Lines.Append('@ō_B  ' + floatTostr(th) + ' sec');
  h0x := calc_h0x;
  memo1.Lines.Append('@ԁB_x   ' + floatTostr(h0x) + ' m');
  vyf := calc_vyf;
  memo1.Lines.Append('@ԁx  ' + floatTostr(vyf) + ' m/s');

  j := 1000;                    // vZ
  dt := tm / 1000;              // t
  sc := 1000;                   // ~PʃXP[
  Series1.Clear;
  Series2.Clear;
  Series3.Clear;
  Series4.Clear;
  case RadioGroup1.ItemIndex of
    0:  begin
          Chart1.LeftAxis.Title.Caption := 'mm';
          Chart1.BottomAxis.Title.Caption := 'msec';
        end;
    1:  begin
          Chart1.LeftAxis.Title.Caption := 'mm';
          Chart1.BottomAxis.Title.Caption := 'mm';
        end;
    2, 3, 4:  begin
          Chart1.LeftAxis.Title.Caption := 'mm/ms';
          Chart1.BottomAxis.Title.Caption := 'msec';
        end;
  end;
  Chart1.LeftAxis.MaximumOffset := 10;
  Label1.Visible := false;
  Label2.Visible := false;
  Label3.Visible := false;
  Label4.Visible := false;
  case RadioGroup1.ItemIndex of
    0:  begin
          Label1.Visible := true;
          Label2.Visible := true;
          Label1.Caption := 'RLX';
          Label2.Caption := 'RLY';
          if checkbox1.Checked = true then begin
            Label3.Visible := true;
            Label4.Visible := true;
            Label3.Caption := 'RX';
            Label4.Caption := 'RY';
          end;
        end;
    1:  begin
          Label1.Visible := true;
          Label2.Visible := true;
          Label1.Caption := 'RLY';
          Label2.Caption := 'RLY';
          if checkbox1.Checked = true then begin
            Label3.Visible := true;
            Label3.Caption := 'RY';
          end;
        end;
    2:  begin
          Label1.Visible := true;
          Label2.Visible := true;
          Label1.Caption := 'RLXx';
          Label2.Caption := 'RLYx';
          if checkbox1.Checked = true then begin
            Label3.Visible := true;
            Label4.Visible := true;
            Label3.Caption := 'RXx';
            Label4.Caption := 'RYx';
          end;
        end;

    3:  begin
          Label1.Visible := true;
          Label1.Caption := 'RLXx';
          if checkbox1.Checked = true then begin
            Label3.Visible := true;
            Label3.Caption := 'RXx';
          end;
        end;
    4:  begin
          Label2.Visible := true;
          Label2.Caption := 'RLYx';
          if checkbox1.Checked = true then begin
            Label4.Visible := true;
            Label4.Caption := 'RYx';
          end;
        end;
  end;

  vxtn := v0x;                // CR@xx͕ωȂ

  for i := 0 to j do begin
    t := i * dt;
    xt := calc_xt(t);         // tbxʒu
    yt := calc_yt(t);         // tbyʒu
    vxt := calc_vxt(t);       // tbxx
    vyt := calc_vyt(t);       // tbyx
    y := xtoy(xt);            // xʒu->yʒu
    xtn := no_drag_x(t);      // CRtbxʒu
    ytn := no_drag_y(t);      // CRtbyʒu
    vytn := no_drag_vy(t);    // CRtbyx
    case RadioGroup1.ItemIndex of
      0:  begin
            Series1.AddXY(t * sc, xt * sc);
            Series2.AddXY(t * sc, yt * sc);
            if checkbox1.Checked = true then begin
              Series3.AddXY(t * sc, xtn * sc);
              Series4.AddXY(t * sc, ytn * sc);
            end;
          end;
      1:  begin
            Series1.AddXY(xt * sc, yt * sc);
            Series2.AddXY(xt * sc, y * sc);
            if checkbox1.Checked = true then begin
              Series3.AddXY(xtn * sc, ytn * sc);
            end;
          end;
      2:  begin
            Series1.AddXY(t * sc, vxt * sc);
            Series2.AddXY(t * sc, vyt * sc);
            if checkbox1.Checked = true then begin
              Series3.AddXY(t* sc, vxtn * sc);
              Series4.AddXY(t* sc, vytn * sc);
            end;
          end;
      3:  begin
            Series1.AddXY(t * sc, vxt * sc);
            if checkbox1.Checked = true then begin
              Series3.AddXY(t * sc, vxtn * sc);
            end;
          end;
      4:  begin
            Series2.AddXY(t * sc, vyt * sc);
            if checkbox1.Checked = true then begin
              Series3.AddXY(t * sc, vytn * sc);
            end;
          end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  memo1.Clear;
end;

end.
